﻿using System;
using System.Diagnostics;
using System.Timers;
using System.Windows;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.Swtor;
using Buddy.Common.Plugins;
using Buddy.Swtor.Objects;
using Action = System.Action;

namespace Buddywing.Plugins
{
    public class TheLuck : IPlugin
    {

        public string Author { get { return "Jon310"; } }
        public Version Version { get { return new Version(0, 2); } }
        public string Name { get { return "The Luck"; } }
        public string Description { get { return "Gambles on the Smuggler's Luck Machines"; } }
        public Window DisplayWindow { get { return null; } }
        private Stopwatch _t;

        public void OnPulse()
        {

            var Luck = ObjectManager.GetObjects<TorObject>().OrderBy(t => t.Distance).FirstOrDefault(t => t.Name == "Smuggler's Luck");
            var Bounty = ObjectManager.GetObjects<TorObject>().OrderBy(t => t.Distance).FirstOrDefault(t => t.Name == "Kingpin's Bounty");

            // Don't run in combat.
            if (BuddyTor.Me.InCombat)
                return;

            _t = new Stopwatch();

            if (!_t.IsRunning)
                _t.Start();

            if (_t.IsRunning && _t.Elapsed.TotalSeconds > 3)
            {
                _t.Reset();
                return;
            }

            if (Luck != null && Luck.Distance < 0.8) Luck.Interact();
            if (Bounty != null && Bounty.Distance < 0.8) Bounty.Interact();

        }


        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>
        public void OnShutdown()
        {
        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>
        public void OnEnabled()
        {
        }

        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>
        public void OnDisabled()
        {
        }

        public bool Equals(IPlugin other)
        {
            return other.Name == Name;
        }
    }
}
